#include <stdio.h>
#include <dos.h>
#define RAMSIZE 56
#define CMOSREGADDR 0x70
#define CMOSPORT 0x71
#define CMOSFIRSTREG 0x0A
#define POWERFLG 0x0D
#define Gx 0x1021

FILE *file;
char buffer[RAMSIZE],fileName[] = "MC146818.RAM";
unsigned char cmosReg;

int ValidControlSum(void);
unsigned char detectRAMPower(void);
unsigned char readRAM(unsigned char);
void writetoRAM(unsigned char,unsigned char);

int main(void)
{
  int count,index,flg;
  unsigned contWord,contSum=0;
  unsigned char pflg,byte;
  pflg = detectRAMPower();
  if ((file = fopen(fileName,"rb"))!=NULL)
  {
    if((pflg & (unsigned char)0x80) == 0)
      printf("CMOSRAM battery power is exhausted.\n");
    rewind(file);
    for(index=0;index<RAMSIZE;index++)
    {
      if((int)(byte=getc(file))==EOF)
      {
        flg=0;
        break;
      }
      buffer[index]=byte;
    }
    if(!ValidControlSum()||!flg)
      {
        printf("Invalid control sum ,\nProgram terminated",index);
        return(1);
      }
    cmosReg = (unsigned char)CMOSFIRSTREG;
    for(index=0;index<RAMSIZE;index++,cmosReg++)
    writetoRAM(cmosReg,(unsigned char)buffer[index]);
  }
  else
  {
    if((pflg & (unsigned char)0x80) == 0)
    {
      printf("CMOSRAM battery power is exhausted.\nProgram terminated.");
      return(1);
    }
    if ((file = fopen(fileName,"wb"))==NULL)
    {
      printf("can't open file to save CMOSRAM.\nProgram terminated.");
      return(1);
    }
    rewind(file);
    cmosReg = (unsigned char)CMOSFIRSTREG;
    for(index=0,contSum=0;index<RAMSIZE;index++,cmosReg++)
    {
      putc((byte=readRAM(cmosReg)),file);
      if(index%2)
        contWord = byte;
      else
      {
        contWord+=0x100*byte;
        for(count=0,pflg=contWord&0x8000;count<16;count++)
        {
          contWord<<=1;
          if(pflg)
            contWord^=Gx;
          pflg=contWord&0x8000;
        }
        contSum^=contWord;
      }
    }
    putc((unsigned char)contWord,file);
    putc((unsigned char)(contWord>>8),file);
  }
  return 0;
}
int ValidControlSum()
{
  int count1,count2,sumFlg;
  unsigned char byte;
  unsigned sum,ramsum,devRes;
  for(sum=0,count1 = 0x10-CMOSFIRSTREG;count1<(RAMSIZE-2);count1+=2)
  {
   devRes = buffer[count1+1]*0x100+buffer[count1];
   for(count2=1,sumFlg=devRes&0x8000;count2<16;count2++)
   {
     devRes<<=1;
     if (sumFlg)
       devRes^=Gx;
     sumFlg=devRes&0x8000;
   }
   sum^=devRes;
  }
  ramsum = buffer[RAMSIZE-1]*0x100+buffer[RAMSIZE-2];
  return ((sum-sum)==0)?1:0;
}
unsigned char detectRAMPower()
{
  unsigned char result,powerflg=(unsigned char)POWERFLG;
  asm{
    mov dx,CMOSREGADDR
    mov al,powerflg
    out dx,al
    mov dx,CMOSPORT
    in al,dx
    mov result,al
  }
  return result;
}
unsigned char readRAM(unsigned char regAddr)
{
  unsigned char result;
  asm{
    mov dx,CMOSREGADDR
    mov al,regAddr
    out dx,al
    mov dx,CMOSPORT
    in al,dx
    mov result,al
  }
  return result;
}
void writetoRAM(unsigned char addr,unsigned char data)
{
  asm{
    mov dx,CMOSREGADDR
    mov al,addr
    out dx,al
    mov dx,CMOSPORT
    mov al,data
    out dx,al
  }
}
